package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("BlockEntry")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class BlockEntry implements Marshallable {
	private Url account;
	private String chain;
	private long index;

    //
	public Url getAccount() {
	    return account;
	}
	public void setAccount(final Url value) {
	    this.account = value;
	}

	public BlockEntry account(final Url value) {
	    setAccount(value);
	    return this;
	}
	public BlockEntry account(final String value) {
	    setAccount(Url.toAccURL(value));
	    return this;
	}
	public String getChain() {
	    return chain;
	}
	public void setChain(final String value) {
	    this.chain = value;
	}

	public BlockEntry chain(final String value) {
	    setChain(value);
	    return this;
	}
	public long getIndex() {
	    return index;
	}
	public void setIndex(final long value) {
	    this.index = value;
	}

	public BlockEntry index(final long value) {
	    setIndex(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.account == null)) {
            marshaller.writeUrl(1, this.account);
        }
        if (!(this.chain == null || this.chain.length() == 0)) {
            marshaller.writeString(2, this.chain);
        }
        marshaller.writeUint(3, this.index);
        return marshaller.array();
    }
}
